# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

from ..core.datetime_utils import serialize_datetime
from .agent import Agent
from .call_human_detection_result import CallHumanDetectionResult
from .call_on_no_human_answer import CallOnNoHumanAnswer
from .call_stage import CallStage
from .call_stage_outcome import CallStageOutcome
from .call_status import CallStatus
from .call_telephony_provider import CallTelephonyProvider
from .twilio_account_connection import TwilioAccountConnection

try:
    import pydantic.v1 as pydantic  # type: ignore
except ImportError:
    import pydantic  # type: ignore


class Call(pydantic.BaseModel):
    id: str
    user_id: str
    status: typing.Optional[CallStatus]
    error_message: typing.Optional[str]
    recording_available: typing.Optional[bool]
    transcript: typing.Optional[str]
    human_detection_result: typing.Optional[CallHumanDetectionResult]
    do_not_call_result: typing.Optional[bool]
    telephony_id: typing.Optional[str]
    stage: typing.Optional[CallStage]
    stage_outcome: typing.Optional[CallStageOutcome]
    to_number: str
    from_number: str
    agent: Agent
    telephony_provider: CallTelephonyProvider
    agent_phone_number: str
    start_time: typing.Optional[dt.datetime]
    end_time: typing.Optional[dt.datetime]
    hipaa_compliant: typing.Optional[bool]
    on_no_human_answer: typing.Optional[CallOnNoHumanAnswer]
    context: typing.Optional[typing.Dict[str, str]]
    run_do_not_call_detection: typing.Optional[bool]
    telephony_account_connection: typing.Optional[TwilioAccountConnection]
    telephony_params: typing.Optional[typing.Dict[str, str]]

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        smart_union = True
        json_encoders = {dt.datetime: serialize_datetime}
