# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

from ..core.datetime_utils import serialize_datetime
from .interrupt_sensitivity import InterruptSensitivity
from .language import Language
from .normalized_agent_endpointing_sensitivity import NormalizedAgentEndpointingSensitivity
from .normalized_agent_ivr_navigation_mode import NormalizedAgentIvrNavigationMode
from .normalized_agent_openai_account_connection import NormalizedAgentOpenaiAccountConnection
from .normalized_agent_prompt import NormalizedAgentPrompt
from .normalized_agent_vector_database import NormalizedAgentVectorDatabase

try:
    import pydantic.v1 as pydantic  # type: ignore
except ImportError:
    import pydantic  # type: ignore


class NormalizedAgent(pydantic.BaseModel):
    id: str
    user_id: str
    name: typing.Optional[str]
    prompt: NormalizedAgentPrompt
    language: typing.Optional[Language]
    actions: typing.List[str]
    voice: str
    initial_message: typing.Optional[str]
    webhook: typing.Optional[str]
    vector_database: typing.Optional[NormalizedAgentVectorDatabase]
    interrupt_sensitivity: typing.Optional[InterruptSensitivity]
    context_endpoint: typing.Optional[str]
    noise_suppression: typing.Optional[bool]
    endpointing_sensitivity: typing.Optional[NormalizedAgentEndpointingSensitivity]
    ivr_navigation_mode: typing.Optional[NormalizedAgentIvrNavigationMode]
    conversation_speed: typing.Optional[float]
    initial_message_delay: typing.Optional[float]
    openai_model_name_override: typing.Optional[str]
    ask_if_human_present_on_idle: typing.Optional[bool]
    openai_account_connection: typing.Optional[NormalizedAgentOpenaiAccountConnection]
    run_do_not_call_detection: typing.Optional[bool]
    llm_temperature: typing.Optional[float]

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        smart_union = True
        json_encoders = {dt.datetime: serialize_datetime}
